import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { XInputGroupItem as XInputGroupItem_internal } from './XInputGroupItem';
import { IgcXInputGroupItemComponent as IgcXInputGroupItemComponent } from './igc-x-input-group-item-component';
export class IgcXInputGroupInputCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcXInputGroupItemComponent.$type) {
            IgcXInputGroupItemComponent.$type = markType(IgcXInputGroupItemComponent, "IgcXInputGroupItemComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcXInputGroupItemComponent.$type) {
            IgcXInputGroupItemComponent.$type = markType(IgcXInputGroupItemComponent, "IgcXInputGroupItemComponent");
        }
        let coll = new SyncableObservableCollection$2(IgcXInputGroupItemComponent.$type, XInputGroupItem_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgcXInputGroupItemComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
