/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XComponentBridge } from "./XComponentBridge";
import { enumGetBox, markType } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { stringStartsWith } from "igniteui-webcomponents-core";
import { trimStart } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let XIconBridge = /*@__PURE__*/ (() => {
    class XIconBridge extends XComponentBridge {
        constructor(a) {
            super(a);
            this.u = "default";
            this.v = null;
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 16: return this.v;
                case 15: return this.u;
                case 18: return enumGetBox(BaseControlTheme_$type, c.i);
                case 44: return c.al;
                case 45: return c.am;
                case 46: return c.an;
                case 47: return c.ak;
                case 48: return c.ao;
                case 49: return c.ag;
            }
            return super.getValue(a, b);
        }
        setValue(a, b, c) {
            super.setValue(a, b, c);
            let d = a;
            switch (b) {
                case 15:
                    {
                        this.u = c;
                        let e = SvgIconRegistry.instance.getSvgPathString(this.u, this.v);
                        if (e != null) {
                            if (stringStartsWith(trimStart(e, ' ', '\n', '\r', '\t'), "<svg")) {
                                d.svg = e;
                            }
                            else {
                                d.svgPath = e;
                            }
                        }
                    }
                    break;
                case 16:
                    {
                        this.v = c;
                        let f = SvgIconRegistry.instance.getSvgPathString(this.u, this.v);
                        if (f != null) {
                            if (stringStartsWith(trimStart(f, ' ', '\n', '\r', '\t'), "<svg")) {
                                d.svg = f;
                            }
                            else {
                                d.svgPath = f;
                            }
                        }
                    }
                    break;
                case 44:
                    d.al = c;
                    break;
                case 45:
                    d.am = c;
                    break;
                case 46:
                    d.an = c;
                    break;
                case 47:
                    d.ak = c;
                    break;
                case 48:
                    d.ao = c;
                    break;
                case 49:
                    d.ag = c;
                    break;
            }
        }
    }
    XIconBridge.$t = /*@__PURE__*/ markType(XIconBridge, 'XIconBridge', XComponentBridge.$);
    return XIconBridge;
})();
